diff --git a/doc/application-api-guide/doxygen.cfg b/doc/application-api-guide/doxygen.cfg
index 75006e2..7951e9e 100644
--- a/doc/application-api-guide/doxygen.cfg
+++ b/doc/application-api-guide/doxygen.cfg
@@ -1,6 +1,6 @@
 PROJECT_NAME = "API Reference Manual for $(WITH_PLATFORM)"
 PROJECT_NUMBER = $(VERSION)
-PROJECT_LOGO = $(SRCDIR)/doc/images/ODP-Logo-HQ.png
+PROJECT_LOGO = $(SRCDIR)/doc/images/ODP-Logo-HQ.svg
 QUIET = YES
 OUTPUT_DIRECTORY = $(DOCDIR)
 FULL_PATH_NAMES = NO
diff --git a/doc/images/ODP-Logo-HQ.png b/doc/images/ODP-Logo-HQ.png
deleted file mode 100644
index 721bf40b185f75ee6899b161a35b2e6fdf0c5ab4..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/doc/images/ODP-Logo-HQ.svg b/doc/images/ODP-Logo-HQ.svg
new file mode 100644
index 0000000..bd83bcd
--- /dev/null
+++ b/doc/images/ODP-Logo-HQ.svg
@@ -0,0 +1,209 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   id="Layer_1"
+   data-name="Layer 1"
+   viewBox="0 0 190 49"
+   version="1.1"
+   inkscape:version="0.91 r13725"
+   sodipodi:docname="ODP-Logo-HQ.svg"
+   width="190"
+   height="49">
+  <metadata
+     id="metadata71">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title>OpenDataPlane-branding_ODP Logo</dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <sodipodi:namedview
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1"
+     objecttolerance="10"
+     gridtolerance="10"
+     guidetolerance="10"
+     inkscape:pageopacity="0"
+     inkscape:pageshadow="2"
+     inkscape:window-width="2511"
+     inkscape:window-height="1416"
+     id="namedview69"
+     showgrid="false"
+     inkscape:zoom="2.253318"
+     inkscape:cx="297.0423"
+     inkscape:cy="74.997335"
+     inkscape:window-x="1969"
+     inkscape:window-y="24"
+     inkscape:window-maximized="1"
+     inkscape:current-layer="Layer_1"
+     fit-margin-top="0"
+     fit-margin-left="0"
+     fit-margin-right="0"
+     fit-margin-bottom="0" />
+  <defs
+     id="defs3">
+    <style
+       id="style5">.cls-1{font-size:44.31px;fill:gray;}.cls-1,.cls-3{font-family:Squada One;}.cls-2,.cls-4{fill:#333;}.cls-3{font-size:76.31px;}.cls-3,.cls-8{fill:#009645;}.cls-4,.cls-5,.cls-9{stroke:#ffe817;stroke-miterlimit:10;stroke-width:4px;}.cls-5{fill:none;}.cls-6,.cls-9{fill:#666;}.cls-7{fill:#1a1a1a;}</style>
+  </defs>
+  <title
+     id="title7">OpenDataPlane-branding_ODP Logo</title>
+  <g
+     id="g4462"
+     transform="matrix(0.32035335,0,0,0.32660788,-0.15849903,0.00353742)">
+    <text
+       transform="translate(531.29,127.66)"
+       id="text9"
+       class="cls-1"
+       style="font-size:44.31000137px;font-family:'Squada One';fill:#808080">.org</text>
+    <rect
+       id="rect11"
+       transform="matrix(0.70710678,-0.70710678,0.70710678,0.70710678,-70.58,74.14)"
+       ry="14.91"
+       rx="14.91"
+       height="114.8"
+       width="114.8"
+       y="46.509998"
+       x="45.290001"
+       class="cls-2"
+       style="fill:#333333" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path13"
+       d="m 102.15,104 0,74.9 0.14,0 c 3.61,-0.15 8.18,-1.58 10.93,-4.34 l 60.1,-60.09 a 14.84,14.84 0 0 0 4.34,-9.92 l 0,-0.53 -75.51,0 z"
+       class="cls-2"
+       inkscape:connector-curvature="0"
+       style="fill:#333333" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       style="fill:#00ffff"
+       id="path15"
+       d="m 102.15,104 0,-75 0.14,0 c 3.61,0.15 8.18,1.58 10.93,4.34 l 60.1,60.09 a 15,15 0 0 1 4.34,10 l 0,0.58 -75.51,0 z"
+       inkscape:connector-curvature="0" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       style="fill:#00ffff"
+       id="path17"
+       d="m 102.15,104 0,74.9 0.15,0 c -3.61,-0.15 -8,-1.58 -10.79,-4.34 l -60,-60.09"
+       inkscape:connector-curvature="0" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path19"
+       d="m 102.15,104 0,-75 0.15,0 c -3.61,0.15 -8,1.58 -10.79,4.34 l -60,60.09"
+       class="cls-2"
+       inkscape:connector-curvature="0"
+       style="fill:#333333" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path23"
+       d="M 102.23,49.19 48.4,103.54 102.75,157.37 156.58,103 Z m 0.38,78.91 -25.12,-24.88 24.88,-25.12 25.12,24.9 z"
+       class="cls-4"
+       inkscape:connector-curvature="0"
+       style="fill:#333333;stroke:#ffe817;stroke-width:4px;stroke-miterlimit:10" />
+    <rect
+       id="rect25"
+       transform="matrix(0.70364278,-0.7105539,0.7105539,0.70364278,-70.07,74.46)"
+       height="35.360001"
+       width="35.360001"
+       y="85.419998"
+       x="84.809998"
+       class="cls-5"
+       style="fill:none;stroke:#ffe817;stroke-width:4px;stroke-miterlimit:10" />
+    <text
+       transform="translate(531.29,127.66)"
+       id="text27"
+       class="cls-1"
+       style="font-size:44.31000137px;font-family:'Squada One';fill:#808080">.org</text>
+    <rect
+       id="rect29"
+       transform="matrix(0.70710678,-0.70710678,0.70710678,0.70710678,-70.58,74.14)"
+       ry="14.91"
+       rx="14.91"
+       height="114.8"
+       width="114.8"
+       y="46.509998"
+       x="45.290001"
+       class="cls-2"
+       style="fill:#333333" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path31"
+       d="m 102.15,104 0,74.9 0.14,0 c 3.61,-0.15 8.18,-1.58 10.93,-4.34 l 60.1,-60.09 a 14.84,14.84 0 0 0 4.34,-9.92 l 0,-0.53 -75.51,0 z"
+       class="cls-6"
+       inkscape:connector-curvature="0"
+       style="fill:#666666" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path33"
+       d="m 102.15,104 0,-75 0.14,0 c 3.61,0.15 8.18,1.58 10.93,4.34 l 60.1,60.09 a 15,15 0 0 1 4.34,10 l 0,0.58 -75.51,0 z"
+       class="cls-7"
+       inkscape:connector-curvature="0"
+       style="fill:#1a1a1a" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path35"
+       d="m 102.15,104 0,74.9 0.15,0 c -3.61,-0.15 -8,-1.58 -10.79,-4.34 l -60,-60.09"
+       class="cls-7"
+       inkscape:connector-curvature="0"
+       style="fill:#1a1a1a" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path37"
+       d="m 102.15,104 0,-75 0.15,0 c -3.61,0.15 -8,1.58 -10.79,4.34 l -60,60.09"
+       class="cls-6"
+       inkscape:connector-curvature="0"
+       style="fill:#666666" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       style="fill:#000000;fill-opacity:0"
+       id="path39"
+       d="m 235.1,86.13 0,30.75 q 0,10.07 -9.46,10.07 l -10.15,0 Q 206,127 206,116.89 l 0,-30.76 q 0,-10.07 9.46,-10.07 l 10.15,0 q 9.49,0 9.49,10.07 z m -10.68,32 0,-33.3"
+       class="cls-8"
+       inkscape:connector-curvature="0" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path41"
+       d="m 260.67,127 -1.6,0"
+       class="cls-8"
+       inkscape:connector-curvature="0"
+       style="fill:#009645" />
+    <path
+       transform="translate(-27.18,-28.91)"
+       id="path65"
+       d="M 102.23,49.19 48.4,103.54 102.75,157.37 156.58,103 Z m 0.38,78.91 -25.12,-24.88 24.88,-25.12 25.12,24.9 z"
+       class="cls-9"
+       inkscape:connector-curvature="0"
+       style="fill:#666666;stroke:#ffe817;stroke-width:4px;stroke-miterlimit:10" />
+    <rect
+       id="rect67"
+       transform="matrix(0.70364278,-0.7105539,0.7105539,0.70364278,-70.07,74.46)"
+       height="35.360001"
+       width="35.360001"
+       y="85.419998"
+       x="84.809998"
+       class="cls-5"
+       style="fill:none;stroke:#ffe817;stroke-width:4px;stroke-miterlimit:10" />
+    <text
+       transform="scale(0.92486289,1.0812414)"
+       sodipodi:linespacing="125%"
+       id="text4199"
+       y="81.79998"
+       x="174.92181"
+       style="font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;font-size:83.23766327px;line-height:125%;font-family:'Squada One';-inkscape-font-specification:'Squada One, Normal';text-align:start;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#009645;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       xml:space="preserve"><tspan
+         y="81.79998"
+         x="174.92181"
+         id="tspan4201"
+         sodipodi:role="line">OpenDataPlane</tspan></text>
+  </g>
+</svg>